﻿'AveryBerkel6710SO 1.14
'
'Annabooks, LLC.
'www.annabooks.com / www.seanliming.com
'Copyright (c) 2006-2014 Annabooks, LLC.    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'
'6/11/2014 - Updated Service Object to Visual Studio 2013 and POS for .NET 1.14
'


Imports Microsoft.PointOfService.BasicServiceObjects
Imports Microsoft.PointOfService
Imports System.Text
Imports System.IO.Ports
Imports System
Imports System.Threading

<ServiceObjectAttribute(DeviceType.Scale, "Avery Berkel 6710 Scale", "Annabooks 6710 Scale SO", 1, 14)> _
Public Class AveryBerkel6710SO114
    Inherits ScaleBasic
    Protected sPort As SerialPort = New SerialPort("COM3", 9600, Parity.Even, 7, StopBits.One)

    Public Overrides Property AsyncMode As Boolean
        Get
            Return False
        End Get
        Set(value As Boolean)

        End Set
    End Property


    Public Overrides ReadOnly Property CapDisplay As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapDisplayText As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapFreezeValue As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapPriceCalculating As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapReadLiveWeightWithTare As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapSetPriceCalculationMode As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapSetUnitPriceWithWeightUnit As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapSpecialTare As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapTarePriority As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapTareWeight As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CapZeroScale As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Function CheckHealth(level As HealthCheckLevel) As String
        Dim theStatus(6) As Char
        Dim FinalStatus As String = "ok"

        sPort.Write("S" & Chr(13))
        Thread.Sleep(1000)

        Try
            theStatus = sPort.ReadTo(Chr(3)).ToCharArray()
        Catch ex As Exception
            FinalStatus = StatusNotReady.ToString()

        End Try

        If (theStatus(1) & theStatus(2) & theStatus(3)) = "S10" Then
            FinalStatus = StatusWeightUnstable.ToString() 'scale is in motion

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S20" Then

            FinalStatus = StatusWeightZero.ToString() 'scale is at zero and stable

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S00" Then

            FinalStatus = StatusStableWeight.ToString() 'Scale Not at Zero and Stable

        ElseIf (theStatus(1) & theStatus(2) & theStatus(3)) = "S11" Then

            FinalStatus = ExtendedErrorOverWeight.ToString() 'Scale over Max Weight

        End If

        Return FinalStatus
    End Function

    Public Overrides ReadOnly Property CheckHealthText As String
        Get
            Return CheckHealth(HealthCheckLevel.Internal)
        End Get
    End Property

    Public Overrides Function DirectIO(command As Integer, data As Integer, obj As Object) As DirectIOData
        Return New DirectIOData(data, obj)
    End Function

    Public Overrides Sub DisplayText(data As String)

    End Sub

    Public Overrides Function DoPriceCalculating(weightData As Integer, tare As Integer, unitPrice As Decimal, unitPriceX As Decimal, weightUnitX As Integer, weightNumeratorX As Integer, weightDenominatorX As Integer, price As Decimal, timeout As Integer) As PriceCalculation

    End Function

    Public Overrides Sub FreezeValue(item As Integer, freeze As Boolean)

    End Sub

    Public Overrides ReadOnly Property MaxDisplayTextChars As Integer
        Get
            Return 0
        End Get
    End Property

    Public Overrides ReadOnly Property MaximumWeight As Decimal
        Get
            Return 30
        End Get
    End Property

    Public Overrides ReadOnly Property MinimumWeight As Decimal
        Get
            Return 0
        End Get
    End Property

    Public Overrides Function ReadLiveWeightWithTare(weightData As Integer, tare As Integer, timeout As Integer) As WeightTareInfo

    End Function

    Public Overrides Function ReadWeight(timeout As Integer) As Decimal
        Dim theWeight(15) As Char
        Dim FinalWeight As Decimal

        sPort.Write("W" & Chr(13))
        Thread.Sleep(1000)

        Try
            theWeight = sPort.ReadTo(Chr(3)).ToCharArray()
        Catch ex As Exception

            Return -1 'failure to connect

        End Try

        If (theWeight(1) & theWeight(2) & theWeight(3)) = "S10" Then

            Return -1 'Scale in motion

        ElseIf (theWeight(1) & theWeight(2) & theWeight(3)) = "S11" Then

            Return -1 'Scale Over Max weight

        Else

            'If there are no errors than display weight
            FinalWeight = (theWeight(1) & theWeight(2) & theWeight(3) & theWeight(4) & theWeight(5) & theWeight(6))
            Return FinalWeight
        End If

    End Function

    Public Overrides ReadOnly Property SalesPrice As Decimal
        Get
            Return 0
        End Get
    End Property

    Public Overrides Sub SetPriceCalculationMode(mode As PriceCalculationMode)

    End Sub

    Public Overrides Sub SetSpecialTare(mode As SpecialTare, data As Integer)

    End Sub

    Public Overrides Sub SetTarePriority(priority As TarePriority)

    End Sub

    Public Overrides Sub SetUnitPriceWithWeightUnit(unitPrice As Decimal, weightUnit As Integer, weightNumerator As Integer, weightDenominator As Integer)

    End Sub

    Public Overrides Property TareWeight As Decimal
        Get
            Return 0
        End Get
        Set(value As Decimal)

        End Set
    End Property
    Public Overrides Property UnitPrice As Decimal
        Get
            Return 0
        End Get
        Set(value As Decimal)

        End Set
    End Property
    Public Overrides ReadOnly Property WeightUnit As WeightUnit
        Get
            Return Microsoft.PointOfService.WeightUnit.Pound
        End Get
    End Property

    Public Overrides Sub ZeroScale()
        sPort.Write("Z" & Chr(13))
        Thread.Sleep(1000)
    End Sub

    Public Overrides Property ZeroValid As Boolean


    Public Overrides Sub Open()
        MyBase.Open()
        sPort.PortName = DevicePath
        sPort.Open()

    End Sub

    Public Overrides Sub Close()

        sPort.Close()
        MyBase.Close()

    End Sub
End Class
